<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Classe du style bilbiothèque ou collection de livre
 *
 * C'est le Proxy qui accède aux méthodes de la collection de livres
 * 
 */
class BookList
{

    private $aBooks = array();
    private $nBookCount = 0;


    public function __construct() 
    {}


    /**
     * Renvoie le nombre de livre de la collection
     * 
     * @return [type] [description]
     */
    public function getBookCount()
    {
        return $this->nBookCount;
    }


    /**
     * Met à jour le nombre de livre de la collection
     * 
     * @param [type] $newCount [description]
     */
    private function setBookCount($newCount)
    {
        $this->nBookCount = $newCount;
    }


    /**
     * Renvoie un livre à partir de son identifiant
     * 
     * @param  [type] $bookNumberToGet [description]
     * @return [type]                  [description]
     */
    public function getBookById($bookNumberToGet)
    {
        // vérifie la validité de l'identifiant
        if ( (is_numeric($bookNumberToGet)) && ($bookNumberToGet <= $this->getBookCount()) )
            return $this->aBooks[$bookNumberToGet];
        else
            return NULL;
    }


    /**
     * Ajoute un objet livre dans la collection
     * 
     * @param Book $book_in [description]
     */
    public function addBook(Book $book_in)
    {
        $this->setBookCount($this->getBookCount() + 1);// mets à jour le nombre de livres de la collection

        $this->aBooks[$this->getBookCount()] = $book_in;// ajoute le livre dans la collection, le tableau

        return $this->getBookCount();
    }
    

    /**
     * Supprime un objet livre de la collection
     * 
     * @param  Book   $book_in [description]
     * @return [type]          [description]
     */
    public function removeBook(Book $book_in)
    {
        $nCount = 0;

        // parcours de tous les livres
        while (++$nCount <= $this->getBookCount())
        {
            // si le livre à supprimer est trouvé
            if ($book_in->getAuthorAndTitle() == $this->aBooks[$nCount]->getAuthorAndTitle())
            {
                // déplace tous les livres et supprime le livre concerné
                for ($x = $nCount; $x < $this->getBookCount(); $x++)
                {
                    $this->aBooks[$x] = $this->aBooks[$x + 1];// le livre suivant est mis à l'emplacement précédent
                }

                $this->setBookCount($this->getBookCount() - 1);// mise à jour du nomnbre de livre, suppression
            }
        }

        return $this->getBookCount();
    }


}

?>