<?php 
/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


/**
 * Classe qui permet de gérer la collection de livre 
 * sans manipuler les objets directement.
 * 
 */
class ProxyBookList
{
  
	private $oBookList = NULL; 


	public function __construct()
	{}

	/**
	 * Renvoie le nombre de livres de la collection
	 * 
	 * @return [type] [description]
	 */
	public function getBookCount()
	{
		// si la collection n'existe pas, création
		if (NULL == $this->oBookList)
			$this->createBookList(); 
	
		return $this->oBookList->getBookCount();
	}


	/**
	 * Ajout d'un livre dans la collection
	 * 
	 * @param [type] $oBook [description]
	 */
	public function addBook($oBook)
	{
		// si la collection n'existe pas, création
		if (NULL == $this->oBookList) 
			$this->createBookList(); 
		
		return $this->oBookList->addBook($oBook);
	}  


	/**
	 * Renvoie un livre à partir de son identifiant
	 * 
	 * @param  [type] $bookNum [description]
	 * @return [type]          [description]
	 */
	public function getBookById($bookNum)
	{
		// si la collection n'existe pas, création
		if (NULL == $this->oBookList) 
		{
			$this->createBookList();
			return NULL;
		}	
		
		return $this->oBookList->getBookById($bookNum);
	}


	/**
	 * Supprime un livre de la collection
	 * 
	 * @param  [type] $book [description]
	 * @return [type]       [description]
	 */
	public function removeBook($book)
	{
		// si la collection n'existe pas, création
		if (NULL == $this->oBookList)
		{
			$this->createBookList();
			return 0;
		}	
		
		return $this->oBookList->removeBook($book);
	}


	/**
	 * Création de la collectino de livres
	 * 
	 * @return [type] [description]
	 */
	public function createBookList()
	{
		$this->oBookList = new BookList();
	}

}



?>